{$I-}
{$V-}
{$M 4096,0,0}

program update;

uses dos;

const
  buflen = 4096;
  verbose       : boolean = false;
  adding        : boolean = false;
  dots          : boolean = false;
  dayold        : boolean = false;
  makereadwrite : boolean = false;

var
  dirinfo                 : searchrec;
  srcdir                  : dirstr;
  srcname                 : namestr;
  srcextn                 : extstr;
  dstdir                  : dirstr;
  param,i,numread,attrib  : word;
  thisparam               : string;
  srcfile,dstfile         : file;
  srcfilename,dstfilename : pathstr;
  dstexists,copying       : boolean;
  srctime,dsttime         : longint;
  block                   : array[0..buflen-1] of char;   {used for copying data}


begin

  if (paramcount < 2) then
    begin
      writeln('UPDATE: Updates files in one directory from another directory - 9 July 1995.');
      writeln('  by Peter Summers <peter@cardiology.medrmh.unimelb.edu.au>');
      writeln;
      writeln('SYNTAX: UPDATE <source filespec> <destination directory> [/ADD] [/VRB]');
      writeln('               [/DOT] [/DAY] [/MRW]');
      halt(1)
    end;

  fsplit(paramstr(1),srcdir,srcname,srcextn);
  dstdir := paramstr(2);

  if not (dstdir[length(dstdir)] in ['\','/',':']) then begin
    assign(dstfile,dstdir);
    getfattr(dstfile,attrib);
    if (doserror<>0) or ((attrib and directory) = 0) then begin
      writeln('Directory '+paramstr(2)+' does not exist.');
      halt(1);
    end;
    dstdir := dstdir + '\';
  end;

  FileMode := 0;   { Source files are open Read-Only. }

  write('Updating '+paramstr(1)+' to '+paramstr(2)+'...');

  for param := 3 to paramcount do begin
    thisparam := paramstr(param);
    for i := 1 to length(thisparam) do thisparam[i] := upcase(thisparam[i]);
    if thisparam = '/ADD' then
      adding := true
    else if thisparam = '/VRB' then
      verbose := true
    else if thisparam = '/DOT' then
      dots := true
    else if thisparam = '/DAY' then
      dayold := true
    else if thisparam = '/MRW' then
      makereadwrite := true;

  end;

  findfirst(paramstr(1),0,dirinfo);
  if doserror=0 then repeat

    srcfilename := srcdir + dirinfo.name;
    srctime := dirinfo.time;
    dstfilename := dstdir + dirinfo.name;

    assign(dstfile,dstfilename);
    reset(dstfile,1);

    dstexists := (IOResult=0);

    if dstexists then begin
      getftime(dstfile,dsttime);
      if dayold then
        copying := ((dsttime and $FFFF0000) <= (srctime and $FFFF0000))
      else
        copying := (dsttime < srctime);
    end else
      copying := adding;

    if copying then begin

      {copy data from input to output file}
      assign(srcfile,srcfilename);
      reset(srcfile,1);
      if (IOresult<>0) then
        write(^M+^J+'Can''t open file '+srcfilename)
      else begin
        if dstexists and makereadwrite then setfattr(dstfile,0);
        rewrite(dstfile,1);
        if (IOresult<>0) then
          write(^M+^J+'Can''t open file '+dstfilename)
        else begin
          while not eof(srcfile) and (IOResult=0) do begin
            blockread(srcfile,block[0],sizeof(block),numread);
            if (IOresult<>0) and not eof(srcfile) then
              writeln(^M+^J+'Can''t read from file '+srcfilename);
            blockwrite(dstfile,block[0],numread);
          end;

          if eof(srcfile) then begin
            if not dayold then setftime(dstfile,srctime);
            write(^M+^J+srcfilename+' copied to '+dstfilename);
          end else
            write(^M+^J+'Can''t write to file '+dstfilename);

          close(srcfile);
          close(dstfile);
        end;
      end;
    end else begin {if not copying}
      if verbose then write(^M+^J+srcfilename+' not copied to ',dstfilename);
      if dstexists then close(dstfile);
    end;

    if dots then if dstexists then write('*') else write('.');

    findnext(dirinfo);

  until doserror<>0 else

    write(^M+^J+'No files found matching '+paramstr(1));

  writeln;

end.

